/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/* ------------------------------------------------------------ */
/*
 * printf.h
 *
 *  Created on: 2009-08-08
 *      Author: lucck
 */
/* ------------------------------------------------------------ */
#ifndef TINY_ALLOC_H_
#define TINY_ALLOC_H_

#ifndef COMPILED_UNDER_ISIX
/* ------------------------------------------------------------ */
#include <stddef.h>

/* ------------------------------------------------------------ */
#ifdef __cplusplus
namespace fnd {
extern "C" {
#endif

/* ------------------------------------------------------------ */
//! Initialize global heap
void tiny_alloc_init(void);

/* ------------------------------------------------------------ */
void *tiny_alloc(size_t size);

/* ------------------------------------------------------------ */

void tiny_free(void *p);

/* ------------------------------------------------------------ */
#ifdef __cplusplus
 }
 }
#endif

#endif /* COMPILED_UNDER_ISIX */

#endif /* TINY_ALLOC_H_ */

