/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/* ------------------------------------------------------------ */
/*
 * printf.h
 *
 *  Created on: 2009-08-08
 *      Author: lucck
 */
/* ------------------------------------------------------------ */
#ifndef TINY_PRINTF_H_
#define TINY_PRINTF_H_
/* ------------------------------------------------------------ */
#include <stddef.h>
/* ------------------------------------------------------------ */
#ifdef __cplusplus
namespace fnd {
extern "C" {
#endif

/* ------------------------------------------------------------ */

int tiny_printf(const char *format, ...);

/* ------------------------------------------------------------ */

int tiny_snprintf(char *out, unsigned long len,  const char *format, ...);


/* ------------------------------------------------------------ */

void register_printf_putc_handler_syslock(int (*fputc)(int, void*),void *arg,
		void (*lock)(void),void (*unlock)(void));

static inline void register_printf_putc_handler(int (*fputc)(int, void*),void *arg)
{
	register_printf_putc_handler_syslock(fputc, arg, NULL, NULL );
}

/* ------------------------------------------------------------ */
#ifdef __cplusplus
 }
 }
#endif


#endif /* PRINTF_H_ */

