/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/* ------------------------------------------------------------ */
/*
 * utils.h
 *
 *  Created on: 2010-03-26
 *      Author: lucck
 */
/* ------------------------------------------------------------ */
#ifndef UTILS_H_
#define UTILS_H_
/* ------------------------------------------------------------ */
#ifdef __cplusplus
namespace fnd {
extern "C" {
#endif
/* ------------------------------------------------------------ */
//Convert string to unsigned
unsigned fnd_atoui(const char *str);

/* ------------------------------------------------------------ */
//Convert unsigned int to ascii
void fnd_uitoa(char *str, unsigned val , int fmt, char fmtch, int base);
/* ------------------------------------------------------------ */
//Convert int to ascii
static inline void fnd_itoa(char *str, int val , int fmt, char fmtch )
{
	if(val < 0 )
	{
		val = -val;
		*str++ = '-';
	}
	fnd_uitoa( str, val, fmt, fmtch, 10 );
}

/* ------------------------------------------------------------ */
#ifdef __cplusplus
 }
 }
#endif
/* ------------------------------------------------------------ */
#endif /* UTILS_H_ */
