/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

#ifndef ISIX_ERROR_H_
#define ISIX_ERROR_H_

/*--------------------------------------------------*/
#ifdef __cplusplus
namespace isix
{
#endif

/*--------------------------------------------------*/
/** Returned error codes definitions */
enum isix_error
{
	ISIX_EOK = 0,       	/** No Error */
	ISIX_ENOMEM = -1,   	/** No memory */
	ISIX_ETIMEOUT = -2, 	/** Timeout   */
	ISIX_EINVARG = -3,  	/** Invalid argument */
	ISIX_EFIFOFULL = -4, 	/** Fifo queue is full */
	ISIX_EBUSY = -5,     	/** Resource already used  */
	ISIX_ENOPRIO = -6   	/** Priority is invalid */
};

/*--------------------------------------------------*/
#ifdef __cplusplus
}
#endif /* __cplusplus */

/*--------------------------------------------------*/
#endif /* _ISIX_ERROR_H__ */

/*--------------------------------------------------*/
