/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*
 * ihandle.h
 *
 *  Created on: 27-03-2011
 *      Author: lucck
 */

#ifndef ISIX_IHANDLE_H_
#define ISIX_IHANDLE_H_

/*--------------------------------------------------------------*/
#ifdef __cplusplus
namespace isix {
#endif
/*--------------------------------------------------------------*/
//Universal handle for multiple objs
union ihandle
{
#ifdef __cplusplus
	ihandle(const sem_t *sem_) : sem(sem_) {}
	ihandle(const fifo_t *fifo_) : fifo(fifo_) {}
	ihandle(const semaphore &sem_) : sem(sem_.sem) {}
	ihandle(const fifo_base &fifo_) : fifo(fifo_.hwnd) {}
private:
#endif
	const sem_t *sem;
	const fifo_t *fifo;
};
/*--------------------------------------------------------------*/
typedef union ihandle ihandle_t;
/*--------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif

/*--------------------------------------------------------------*/
#endif /* IHANDLE_H_ */
