/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*-----------------------------------------------------------------------*/
#ifndef __ISIX_PRINTK_H
#define __ISIX_PRINTK_H
/*-----------------------------------------------------------------------*/
#include <isix/config.h>
/*-----------------------------------------------------------------------*/
#if (ISIX_DEBUG_ENABLE == ISIX_DBG_OFF)
#define isix_printk(...)
#else
#include <tiny_printf.h>

#define isix_printk(...) do { isixp_enter_critical(); \
						 tiny_printf("%s:%d|%s|",__FILE__,__LINE__,__FUNCTION__); \
						 tiny_printf(__VA_ARGS__); \
						 tiny_printf("\r\n"); \
						 isixp_exit_critical(); \
					   } while(0)
#endif

/*-----------------------------------------------------------------------*/
#endif


