/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*
 * fifo.h
 *
 *  Created on: 24-03-2011
 *      Author: lucck
 */

#ifndef ISIX_PRV_FIFO_H_
#define ISIX_PRV_FIFO_H_
/*-------------------------------------------------------*/

/* Queue structure */
struct fifo_struct
{
	enum ihandle_type type;	//Structure type
	char *rx_p;     //Pointer to rx
    char *tx_p;     //Pointer to tx
    char *mem_p;    //Pointer to allocated memory
    int size;       //Total fifo size
    int elem_size; //Element count
    sem_t rx_sem;  //Semaphore rx
    sem_t tx_sem;  //Semaphore for tx
};


/*-------------------------------------------------------*/
#endif /* FIFO_H_ */
