/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*
 * irqtimers.h
 *
 *  Created on: 05-03-2011
 *      Author: lucck
 */

#ifndef ISIX_PRV_IRQTIMERS_H_
#define ISIX_PRV_IRQTIMERS_H_
/*-----------------------------------------------------------------------*/
#include <isix/types.h>
#include <prv/list.h>
/*-----------------------------------------------------------------------*/
#ifdef ISIX_CONFIG_USE_TIMERS
/*-----------------------------------------------------------------------*/
//Initialize vtimers infrastructure
void isixp_vtimer_init(void);
/*-----------------------------------------------------------------------*/
//Call timer funcs in the interrupt context
void isixp_vtimer_handle_time(tick_t jiffies);
/*-----------------------------------------------------------------------*/
struct vtimer_struct
{
	tick_t jiffies;	      /* Next timeout handle */
	tick_t timeout;			 /* Timeout timer value */
	void (*timer_handler)(void*); /* Next timer call */
	void *arg;					  /* Function pointer */
	list_t inode;				  /* Innode list */
};
/*-----------------------------------------------------------------------*/
#else
static inline void isixp_vtimer_init(void) {}
static inline void isixp_vtimer_handle_time(tick_t jiffies) { (void)jiffies; }
#endif
/*-----------------------------------------------------------------------*/
#endif /* IRQTIMERS_H_ */
