/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*--------------------------------------------------------------*/
/*
 * multiple_objects.h
 *
 *  Created on: 26-03-2011
 *      Author: lucck
 */
/*--------------------------------------------------------------*/
#ifndef ISIX_PRV_MULTIPLE_OBJECTS_H_
#define ISIX_PRV_MULTIPLE_OBJECTS_H_
/*--------------------------------------------------------------*/

#ifdef ISIX_CONFIG_USE_MULTIOBJECTS	//If multiobjects enable

/*--------------------------------------------------------------*/
#include <isix/types.h>
#include <isix/scheduler.h>

/*--------------------------------------------------------------*/
struct multiple_obj
{
	const union ihandle *ihwnd;	//Ihandle pointer
	size_t ihwnd_len;		//Ihandle len
	task_t *task_id;		//Task owner
	list_t inode;			//Multiple objects inode
};

/*--------------------------------------------------------------*/
//Wait for multi object
typedef struct multiple_obj multiple_obj_t;


/*--------------------------------------------------------------*/
//Initialize the multiple objects waiting
void ixixp_multiple_objects_init( void );

/*--------------------------------------------------------------*/
//Wakeup multiple wating tasks
int isixp_wakeup_multiple_waiting_tasks( const sem_t *sem, int (*wkup_fun)(task_t *) );

/*--------------------------------------------------------------*/

void isixp_delete_from_multiple_wait_list(const task_t *task );

/*--------------------------------------------------------------*/
#else /*ISIX_CONFIG_USE_MULTIOBJECTS */

static inline void ixixp_multiple_objects_init( void ) {}

#endif /*ISIX_CONFIG_USE_MULTIOBJECTS */

#endif /* MULTIPLE_OBJECTS_H_ */
