/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

#ifndef PRV_ISIX_SEMAPHORE_H_
#define PRV_ISIX_SEMAPHORE_H_


#include <prv/list.h>

/*--------------------------------------------------------------*/
enum ihandle_type
{
	IHANDLE_T_SEM=1,
	IHANDLE_T_FIFO=2
};

/*--------------------------------------------------------------*/

//Structure of semaphore
struct sem_struct
{
    enum ihandle_type type;
	//Semaphore val
    int value;
    //Task val waiting for semaphore
    list_entry_t sem_task;
    //Resource type
    bool static_mem;
    //Semaphore limit value
    int limit_value;
};

/*--------------------------------------------------------------*/

//Semaphore can by destroyed
static inline bool isixp_sem_can_destroy(sem_t *sem)
{
   return list_isempty(&sem->sem_task);
}

/*--------------------------------------------------------------*/

#endif
