/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*
 * lcddisp.h
 *
 *  Created on: 08-01-2012
 *      Author: lucck
 */
/* ------------------------------------------------------------------ */
#ifndef LCDDISP_H_
#define LCDDISP_H_
/* ------------------------------------------------------------------ */
#include "hd44xx_display.hpp"
/* ------------------------------------------------------------------ */
namespace dev
{

class lcd_disp: public fnd::lcd::hd44xx_display
{
public:
	virtual ~lcd_disp();
	void enable(bool en);
protected:
	virtual void write8_i(uint8_t addr, uint8_t value );
	virtual void write8_n(uint8_t addr, uint8_t value );
	virtual uint8_t read8( uint8_t addr );
	virtual void mdelay( unsigned period);
private:
	void udelay( unsigned period);
};
/* ------------------------------------------------------------------ */
} /* namespace app */
/* ------------------------------------------------------------------ */
#endif /* LCDDISP_H_ */
/* ------------------------------------------------------------------ */
