/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/*
 * sys_time.cpp
 *
 *  Created on: 22-01-2012
 *      Author: lucck
 */
/* ------------------------------------------------------------------ */
#include "sys_time.hpp"

/* ------------------------------------------------------------------ */
namespace dev {
namespace tim {
/* ------------------------------------------------------------------ */
namespace _internal
{
	void stepup_converter_tick_handler();
	void keyboard_tick_handler();
}
/* ------------------------------------------------------------------ */
namespace
{
	volatile tick_t ticks;
}
/* ------------------------------------------------------------------ */
//Read tick
tick_t read_tick()
{
	return ticks;
}

/* ------------------------------------------------------------------ */
extern "C"
{
//Systick isr vector
void systick_isr_vector(void) __attribute__ ((interrupt));
void systick_isr_vector(void)
{
	++ticks;
	_internal::stepup_converter_tick_handler();
	_internal::keyboard_tick_handler();
}

}	//Extern C
/* ------------------------------------------------------------------ */
}}	//Namespaces
/* ------------------------------------------------------------------ */
