/* 
    LCFMETER - Firmware for measure L, C, F using STM32F100 device
    Copyright (C) 2012  Lucjan Bryndza <lucck@boff.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

/* ------------------------------------------------------------------ */
/*
 * example1.c
 *
 * Proof of concept of LCF meter app
 * without isixrtos
 *
 *  Created on: 23-12-2011
 *      Author: lucck
 */
/* ------------------------------------------------------------------ */
#include "config.h"
#include "theapplication.h"
#include <dbglog.h>
#include <stm32f10x_lib.h>
#include <usart_simple.h>
/* ------------------------------------------------------------------ */
/* Main logic function */

int main(void)
{
    using namespace stm32;
    //Usart debug init
    dblog_init( stm32::usartsimple_putc, NULL, stm32::usartsimple_init,
    		USART1,115200,false, config::PCLK1_HZ, config::PCLK2_HZ );
    dbprintf(" App started ");
    //Application object
    static app::the_application app;
    app.run();
    dbprintf(" App finished ");
    return 0;
}

/* ------------------------------------------------------------------ */
